package com.dbnt.sims.config;

import com.dbnt.sims.menuMgt.service.MenuMgtService;
import com.dbnt.sims.organMgt.service.OrganConfigService;
import com.dbnt.sims.userInfo.model.UserInfo;
import com.dbnt.sims.codeMgt.service.CodeMgtService;

import com.dbnt.sims.userInfo.service.UserInfoService;
import lombok.RequiredArgsConstructor;
import org.springframework.security.core.annotation.AuthenticationPrincipal;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpSession;

@RestController
@RequiredArgsConstructor
public class BaseController {

  private final CodeMgtService codeMgtService;
  private final OrganConfigService organConfigService;
  private final MenuMgtService menuMgtService;
  private final UserInfoService userInfoService;

  @GetMapping("/")
  public ModelAndView loginCheck(@AuthenticationPrincipal UserInfo loginUser) {
    ModelAndView mav = null;
    if(loginUser == null){
      mav = new ModelAndView("redirect:/login");
    }else{
      mav = new ModelAndView("redirect:/dashboard");
    }
    return mav;
  }

  @GetMapping("/login")
  public ModelAndView goLogin() { 
    ModelAndView mav = new ModelAndView("login/login");
    mav.addObject("OgList", codeMgtService.selectCodeMgtList("OG"));
    mav.addObject("OfcList", codeMgtService.selectCodeMgtList("OFC"));
    return mav;
  }

  @GetMapping("/login-error")
  public ModelAndView loginError() {
    ModelAndView mav = new ModelAndView("login/login");
    mav.addObject("OgList", codeMgtService.selectCodeMgtList("OG"));
    mav.addObject("OfcList", codeMgtService.selectCodeMgtList("OFC"));
    mav.addObject("loginError", true);
    return mav;
  }

  @GetMapping("/denied")
  public ModelAndView doDenied() {
    ModelAndView mav = new ModelAndView("login/denied");
    return mav;
  }

  @GetMapping("/dashboard")
  public ModelAndView dashboard() {
    ModelAndView mav = new ModelAndView("login/dashboard");
    return mav;
  }

  public void setSession(@AuthenticationPrincipal UserInfo loginUser, HttpSession session){
    loginUser.setDownOrganCdList(organConfigService.selectDownOrganListWhereUserOgCd(loginUser.getOgCd()));
    loginUser.setUpOrganCdList(organConfigService.selectUpOrganListWhereUserOgCd(loginUser.getOgCd()));
    session.setAttribute("menuList", menuMgtService.selectAccessMenuListWhereUserSeq(loginUser.getUserSeq()));
    session.setAttribute("commonCode", codeMgtService.getCommonCode());
  }
}
